
"""
Auto-generated by CVXPYgen on November 18, 2023 at 15:13:31.
Content: Custom solve method for CVXPY interface.
"""

import time
import warnings
import numpy as np
from cvxpy.reductions import Solution
from cvxpy.problems.problem import SolverStats
from DEBUG import cpg_module


standard_settings_names = {"max_iters": "maxit"}


def cpg_solve(prob, updated_params=None, **kwargs):

    # set flags for updated parameters
    upd = cpg_module.cpg_updated()
    if updated_params is None:
        updated_params = ["xi", "xs"]
    for p in updated_params:
        try:
            setattr(upd, p, True)
        except AttributeError:
            raise AttributeError(f"{p} is not a parameter.")

    # set solver settings
    cpg_module.set_solver_default_settings()
    for key, value in kwargs.items():
        try:
            eval(f'cpg_module.set_solver_{standard_settings_names.get(key, key)}(value)')
        except AttributeError:
            raise AttributeError(f'Solver setting "{key}" not available.')

    # set parameter values
    par = cpg_module.cpg_params()
    param_dict = prob.param_dict
    par.xi = list(param_dict["xi"].value.flatten(order="F"))
    par.xs = list(param_dict["xs"].value.flatten(order="F"))

    # solve
    t0 = time.time()
    res = cpg_module.solve(upd, par)
    t1 = time.time()

    # store solution in problem object
    prob._clear_solution()
    prob.var_dict['gama'].save_value(np.array(res.cpg_prim.gama))
    prob.var_dict['Q'].save_value(np.array(res.cpg_prim.Q).reshape((4, 4), order='F'))
    prob.var_dict['Y'].save_value(np.array(res.cpg_prim.Y).reshape((2, 4), order='F'))
    prob.constraints[0].save_dual_value(np.array(res.cpg_dual.d0))
    prob.constraints[1].save_dual_value(np.array(res.cpg_dual.d1).reshape((4, 4), order='F'))
    prob.constraints[2].save_dual_value(np.array(res.cpg_dual.d2).reshape((5, 5), order='F'))
    prob.constraints[3].save_dual_value(np.array(res.cpg_dual.d3).reshape((12, 12), order='F'))
    prob.constraints[4].save_dual_value(np.array(res.cpg_dual.d4).reshape((6, 6), order='F'))

    # store additional solver information in problem object
    prob._status = "%d (for description visit https://oxfordcontrol.github.io/ClarabelDocs/)" % res.cpg_info.status
    if abs(res.cpg_info.obj_val) == 1e30:
        prob._value = np.sign(res.cpg_info.obj_val) * np.inf
    else:
        prob._value = res.cpg_info.obj_val
    primal_vars = {var.id: var.value for var in prob.variables()}
    dual_vars = {c.id: c.dual_value for c in prob.constraints}
    solver_specific_stats = {'obj_val': res.cpg_info.obj_val,
                             'status': prob._status,
                             'iter': res.cpg_info.iter,
                             'pri_res': res.cpg_info.pri_res,
                             'dua_res': res.cpg_info.dua_res,
                             'time': res.cpg_info.time}
    attr = {'solve_time': t1 - t0, 'solver_specific_stats': solver_specific_stats, 'num_iters': res.cpg_info.iter}
    prob._solution = Solution(prob.status, prob.value, primal_vars, dual_vars, attr)
    results_dict = {'solver_specific_stats': solver_specific_stats,
                    'num_iters': res.cpg_info.iter,
                    'solve_time': t1 - t0}
    prob._solver_stats = SolverStats(results_dict, 'CLARABEL')

    return prob.value
