
"""
Auto-generated by CVXPYgen on April 22, 2024 at 16:37:30.
Content: Custom solve method for CVXPY interface.
"""

import time
import warnings
import numpy as np
from cvxpy.reductions import Solution
from cvxpy.problems.problem import SolverStats
from MPC_code import cpg_module


standard_settings_names = {"max_iters": "maxit"}


def cpg_solve(prob, updated_params=None, **kwargs):

    # set flags for updated parameters
    upd = cpg_module.cpg_updated()
    if updated_params is None:
        updated_params = ["Psqrt", "Qsqrt", "Rsqrt", "A", "B", "x_init"]
    for p in updated_params:
        try:
            setattr(upd, p, True)
        except AttributeError:
            raise AttributeError(f"{p} is not a parameter.")

    # set solver settings
    cpg_module.set_solver_default_settings()
    for key, value in kwargs.items():
        try:
            eval(f'cpg_module.set_solver_{standard_settings_names.get(key, key)}(value)')
        except AttributeError:
            raise AttributeError(f'Solver setting "{key}" not available.')

    # set parameter values
    par = cpg_module.cpg_params()
    param_dict = prob.param_dict
    par.Psqrt = list(param_dict["Psqrt"].value.flatten(order="F"))
    par.Qsqrt = list(param_dict["Qsqrt"].value.flatten(order="F"))
    par.Rsqrt = list(param_dict["Rsqrt"].value.flatten(order="F"))
    par.A = list(param_dict["A"].value.flatten(order="F"))
    par.B = list(param_dict["B"].value.flatten(order="F"))
    par.x_init = list(param_dict["x_init"].value.flatten(order="F"))

    # solve
    t0 = time.time()
    res = cpg_module.solve(upd, par)
    t1 = time.time()

    # store solution in problem object
    prob._clear_solution()
    prob.var_dict['X'].save_value(np.array(res.cpg_prim.X).reshape((6, 11), order='F'))
    prob.var_dict['U'].save_value(np.array(res.cpg_prim.U).reshape((3, 10), order='F'))
    prob.constraints[0].save_dual_value(np.array(res.cpg_dual.d0).reshape((6, 10), order='F'))
    prob.constraints[1].save_dual_value(np.array(res.cpg_dual.d1).reshape((3, 10), order='F'))
    prob.constraints[2].save_dual_value(np.array(res.cpg_dual.d2).reshape(6))

    # store additional solver information in problem object
    prob._status = "%d (for description visit https://oxfordcontrol.github.io/ClarabelDocs/)" % res.cpg_info.status
    if abs(res.cpg_info.obj_val) == 1e30:
        prob._value = np.sign(res.cpg_info.obj_val) * np.inf
    else:
        prob._value = res.cpg_info.obj_val
    primal_vars = {var.id: var.value for var in prob.variables()}
    dual_vars = {c.id: c.dual_value for c in prob.constraints}
    solver_specific_stats = {'obj_val': res.cpg_info.obj_val,
                             'status': prob._status,
                             'iter': res.cpg_info.iter,
                             'pri_res': res.cpg_info.pri_res,
                             'dua_res': res.cpg_info.dua_res,
                             'time': res.cpg_info.time}
    attr = {'solve_time': t1 - t0, 'solver_specific_stats': solver_specific_stats, 'num_iters': res.cpg_info.iter}
    prob._solution = Solution(prob.status, prob.value, primal_vars, dual_vars, attr)
    results_dict = {'solver_specific_stats': solver_specific_stats,
                    'num_iters': res.cpg_info.iter,
                    'solve_time': t1 - t0}
    prob._solver_stats = SolverStats(results_dict, 'CLARABEL')

    return prob.value
