Thank you for your interest in contributing to ECOS, a project maintained by embotech ("We" or "Us").

The purpose of this contributor agreement ("Agreement") is to clarify and document the rights granted by contributors to Us. By contributing to the project in any traceable way (pull requests, issues, emails etc.), you agree to these terms.

## 1. DEFINITIONS

"**You**" means the Individual Copyright owner who submits a Contribution to Us. If You are an employee and submit the Contribution as part of your employment, You have had Your employer approve this Agreement or sign the Entity version of this document (see the CONTRIBUTING-entity.md file).

"**Contribution**" means any original work of authorship (software and/or documentation) including any modifications or additions to an existing work, Submitted by You to Us, in which You own the Copyright. If You do not own the Copyright in the entire work of authorship, please contact Us at <span id="i-tmp-project-email-2">info@embotech.com</span>.

"**Copyright**" means all rights protecting works of authorship owned or controlled by You, including copyright, moral and neighboring rights, as appropriate, for the full term of their existence including any extensions by You.

"**Material**" means the software or documentation made available by Us to third parties. When this Agreement covers more than one software project, the Material means the software or documentation to which the Contribution was Submitted. After You Submit the Contribution, it may be included in the Material.

"**Submit**" means any form of physical, electronic, or written communication sent to Us, including but not limited to electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, Us, but excluding communication that is conspicuously marked or otherwise designated in writing by You as "Not a Contribution."

"**Submission Date**" means the date You Submit a Contribution to Us.

"**Documentation**" means any non-software portion of a Contribution.

## 2. LICENSE GRANT
### 2.1 Copyright License to Us
Subject to the terms and conditions of this Agreement, You hereby grant to Us a worldwide, royalty-free, NON-exclusive, perpetual and irrevocable license, with the right to transfer an unlimited number of non-exclusive licenses or to grant sublicenses to third parties, under the Copyright covering the Contribution to use the Contribution by all means, including, but not limited to:
<ul>
    <li>to publish the Contribution,</li>
    <li> to modify the Contribution, to prepare derivative works based upon or containing the Contribution and to combine the Contribution with other software code,</li>
    <li>to reproduce the Contribution in original or modified form,</li>
    <li>to distribute, to make the Contribution available to the public, display and publicly perform the Contribution in original or modified form.</li>
</ul>

### 2.2 Moral Rights 
Moral rights remain unaffected to the extent they are recognized and not waivable by applicable law. Notwithstanding, You may add your name in the header of the source code files of Your Contribution and We will respect this attribution when using Your Contribution.

## 3. PATENTS
### 3.1 Patent License

Subject to the terms and conditions of this Agreement You hereby grant to us a worldwide, royalty-free, non-exclusive, 
perpetual and irrevocable (except as stated in Section 3.2) patent license, 
with the right to transfer an unlimited number of non-exclusive licenses or to grant sublicenses to third parties, 
to make, have made, use, sell, offer for sale, import and otherwise transfer the Contribution and the Contribution in 
combination with the Material (and portions of such combination). This license applies to all patents owned or controlled by 
You, whether already acquired or hereafter acquired, that would be infringed by making, having made, using, selling, offering 
for sale, importing or otherwise transferring of Your Contribution(s) alone or by combination of Your Contribution(s) 
with the Material.

### 3.2 Revocation of Patent License
You reserve the right to revoke the patent license stated in section 3.1 if we make any infringement claim that is 
targeted at your Contribution and not asserted for a Defensive Purpose. An assertion of claims of the Patents shall be 
considered for a "Defensive Purpose" if the claims are asserted against an entity that has filed, maintained, threatened, or 
voluntarily participated in a patent infringement lawsuit against Us or any of Our licensees.

## 4. DISCLAIMER
THE CONTRIBUTION IS PROVIDED "AS IS". MORE PARTICULARLY, ALL EXPRESS OR IMPLIED WARRANTIES INCLUDING, WITHOUT LIMITATION, ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED BY YOU TO US AND BY US TO YOU. TO THE EXTENT THAT ANY SUCH WARRANTIES CANNOT BE DISCLAIMED, SUCH WARRANTY IS LIMITED IN DURATION TO THE MINIMUM PERIOD PERMITTED BY LAW.

## 5. Consequential Damage Waiver
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL YOU OR US BE LIABLE FOR ANY LOSS OF PROFITS, LOSS OF ANTICIPATED SAVINGS, LOSS OF DATA, INDIRECT, SPECIAL, INCIDENTAL, CONSEQUENTIAL AND EXEMPLARY DAMAGES ARISING OUT OF THIS AGREEMENT REGARDLESS OF THE LEGAL OR EQUITABLE THEORY (CONTRACT, TORT OR OTHERWISE) UPON WHICH THE CLAIM IS BASED.

## 6. Approximation of Disclaimer and Damage Waiver
IF THE DISCLAIMER AND DAMAGE WAIVER MENTIONED IN SECTION 4 AND SECTION 5 CANNOT BE GIVEN LEGAL EFFECT UNDER APPLICABLE LOCAL LAW, 
REVIEWING COURTS SHALL APPLY LOCAL LAW THAT MOST CLOSELY APPROXIMATES AN ABSOLUTE WAIVER OF ALL CIVIL LIABILITY IN CONNECTION WITH 
THE CONTRIBUTION.

## 7. Term
**7.1** This Agreement shall come into effect upon Your acceptance of the terms and conditions.

**7.2** In the event of a termination of this Agreement Sections 4, 5, 6, 7 and 8 shall survive such termination and shall remain in 
full force thereafter. For the avoidance of doubt, Contributions  that are already licensed under a free and open source license at 
the date of the termination shall remain in full force after the termination of this Agreement.

## 8. Miscellaneous
**8.1** This Agreement and all disputes, claims, actions, suits or other proceedings arising out of this agreement or relating in any way to it shall be governed by the laws of <span id="i-tmp-project-jurisdiction">Switzerland</span> excluding its private international law provisions.</p>

**8.2** This Agreement sets out the entire agreement between You and Us for Your Contributions to Us and overrides all other agreements or 
understandings.

**8.3** If any provision of this Agreement is found void and unenforceable, such provision will be replaced to the extent possible 
with a provision that comes closest to the meaning of the original provision and that is enforceable. The terms and conditions set 
forth in this Agreement shall apply notwithstanding any failure of essential purpose of this Agreement or any limited remedy to the 
maximum extent possible under law.

**8.4** You agree to notify Us of any facts or circumstances of which you become aware that would make this Agreement inaccurate 
in any respect.
